float4x4 MVPMatrix;
float4 LightDirection;

struct VS_INPUT {
  float4 pos: POSITION;
  float4 normal: NORMAL;
  float4 uv: TEXCOORD;
};

struct VS_OUTPUT {
  float4 pos: POSITION;
  float4 uv: TEXCOORD;
};

VS_OUTPUT main(VS_INPUT In) {
  VS_OUTPUT Out = (VS_OUTPUT)0;
  
  Out.pos = mul(float4(In.pos.xyz, 1.0), transpose(MVPMatrix));
  Out.uv = float4(In.uv.xy, max(dot(In.normal.xyz, -LightDirection.xyz), 0.0), 0);
  
  return Out;
}